/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __GDAM_MIDI_SELECTOR_H_
#define __GDAM_MIDI_SELECTOR_H_


typedef struct _GdamMidiSelector GdamMidiSelector;
typedef struct _GdamMidiSelectorClass GdamMidiSelectorClass;

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include "../gdamskin.h"
#include "../../component/plugins/gdammididevice.h"
#include <gtk/gtkentry.h>
#include <gtk/gtkclist.h>

GtkType gdam_midi_selector_get_type();
#define GDAM_TYPE_MIDI_SELECTOR			(gdam_midi_selector_get_type ())
#define GDAM_MIDI_SELECTOR(obj)              (GTK_CHECK_CAST ((obj), GDAM_TYPE_MIDI_SELECTOR, GdamMidiSelector))
#define GDAM_MIDI_SELECTOR_CLASS(klass)      (GTK_CHECK_CLASS_CAST ((klass), GDAM_TYPE_MIDI_SELECTOR, GdamMidiSelectorClass))
#define GDAM_IS_MIDI_SELECTOR(obj)           (GTK_CHECK_TYPE ((obj), GDAM_TYPE_MIDI_SELECTOR))
#define GDAM_IS_MIDI_SELECTOR_CLASS(klass)   (GTK_CHECK_CLASS_TYPE ((klass), GDAM_TYPE_MIDI_SELECTOR))

struct _GdamMidiSelectorClass {
	GdamSkinClass		skin_class;
	void                          (*done_groping)(GdamMidiSelector*);
};

struct _GdamMidiSelector {
	GdamSkin			skin;
	GtkEntry*			entry;

	GdamMidiDevice*			selected_device;
	GdamMidiEventType		selected_event_type;
	int				selected_channel;
	int				selected_which_param;

	/* The clist subscribes to the emission of all
	 * new-trap events (of GdamMidiDevices).
	 */
	GtkCList*			clist;
	guint				emission_id;

	GdamMidiTrap*			grope;
	guint				grope_emission_id;
};

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
